/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 CANģʽ׼֡չ֡շ
 CAN_Tx(PB9),CAN_Rx(PB8)
 CANշʾ Standard_Frame  Extended_Frame
 Standard_Frame 132bitλģʽ216bitλģʽ
 132bitʶбģʽ216bitʶбģʽ
 Extended_Frame132bitλģʽ

*/

#include "debug.h"

/* CAN Mode Definition */
#define TX_MODE   0
#define RX_MODE   1


#define CAN_MODE   RX_MODE


void CAN_Mode_Init( u8 tsjw, u8 tbs2, u8 tbs1, u16 brp, u8 mode )
{
    GPIO_InitTypeDef GPIO_InitSturcture={0};
    CAN_InitTypeDef CAN_InitSturcture={0};
    CAN_FilterInitTypeDef CAN_FilterInitSturcture={0};
    NVIC_InitTypeDef       NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOB, ENABLE );
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_CAN1, ENABLE );
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_CAN2, ENABLE );

    GPIO_PinRemapConfig( GPIO_Remap1_CAN1, ENABLE);

    GPIO_InitSturcture.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitSturcture.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitSturcture.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( GPIOB, &GPIO_InitSturcture);

    GPIO_InitSturcture.GPIO_Pin = GPIO_Pin_8;
    GPIO_InitSturcture.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init( GPIOB, &GPIO_InitSturcture);

    GPIO_InitSturcture.GPIO_Pin = GPIO_Pin_13;
    GPIO_InitSturcture.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitSturcture.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( GPIOB, &GPIO_InitSturcture);

    GPIO_InitSturcture.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitSturcture.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init( GPIOB, &GPIO_InitSturcture);

    CAN_InitSturcture.CAN_TTCM = DISABLE;
    CAN_InitSturcture.CAN_ABOM = DISABLE;
    CAN_InitSturcture.CAN_AWUM = DISABLE;
    CAN_InitSturcture.CAN_NART = ENABLE;
    CAN_InitSturcture.CAN_RFLM = DISABLE;
    CAN_InitSturcture.CAN_TXFP = DISABLE;
    CAN_InitSturcture.CAN_Mode = mode;
    CAN_InitSturcture.CAN_SJW = tsjw;
    CAN_InitSturcture.CAN_BS1 = tbs1;
    CAN_InitSturcture.CAN_BS2 = tbs2;
    CAN_InitSturcture.CAN_Prescaler = brp;
    CAN_Init( CAN1, &CAN_InitSturcture );
    CAN_Init( CAN2, &CAN_InitSturcture );


/* identifier/mask mode, One 32-bit filter, StdId: 0x317 */

    CAN_FilterInitSturcture.CAN_FilterNumber = 4;
    CAN_FilterInitSturcture.CAN_FilterMode = CAN_FilterMode_IdMask;
    CAN_FilterInitSturcture.CAN_FilterScale = CAN_FilterScale_16bit;
    CAN_FilterInitSturcture.CAN_FilterIdHigh = 0x0000;
    CAN_FilterInitSturcture.CAN_FilterIdLow = 0x0000;
    CAN_FilterInitSturcture.CAN_FilterMaskIdHigh = 0x0000;
    CAN_FilterInitSturcture.CAN_FilterMaskIdLow = 0x0000;
    CAN_FilterInitSturcture.CAN_FilterFIFOAssignment = CAN_Filter_FIFO1;
    CAN_FilterInitSturcture.CAN_FilterActivation = ENABLE;
    CAN_FilterInit( &CAN_FilterInitSturcture );//CAN1

    CAN_SlaveStartBank(7);//CAN2  Ŀʼ
    CAN_FilterInitSturcture.CAN_FilterNumber = 7;
    CAN_FilterInitSturcture.CAN_FilterMode = CAN_FilterMode_IdMask;
    CAN_FilterInitSturcture.CAN_FilterScale = CAN_FilterScale_32bit;
    CAN_FilterInitSturcture.CAN_FilterIdHigh = 0x62E0;
    CAN_FilterInitSturcture.CAN_FilterIdLow = 0;
    CAN_FilterInitSturcture.CAN_FilterMaskIdHigh = 0x0000;
    CAN_FilterInitSturcture.CAN_FilterMaskIdLow = 0x0000;
    CAN_FilterInitSturcture.CAN_FilterFIFOAssignment = CAN_Filter_FIFO0;
    CAN_FilterInitSturcture.CAN_FilterActivation = ENABLE;
    CAN_FilterInit( &CAN_FilterInitSturcture );//CAN2

    CAN_ITConfig(CAN1,CAN_IT_FMP1,ENABLE);                 //FIFO1
    CAN_ITConfig(CAN2,CAN_IT_FMP0,ENABLE);                 //FIFO0

    NVIC_InitStructure.NVIC_IRQChannel = CAN1_RX1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = CAN2_RX0_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

/*********************************************************************
 * @fn      CAN_Send_Msg
 *
 * @brief   CAN Transmit function.
 *
 * @param   msg - Transmit data buffer.
 *          len - Data length.
 *
 * @return  0 - Send successful.
 *          1 - Send failed.
 */
u8 CAN_Send_Msg( u8 *msg, u8 len )
{
	u8 mbox;
	u16 i = 0;
	
	CanTxMsg CanTxStructure;

#if (Frame_Format == Standard_Frame)
	CanTxStructure.StdId = 0x317;		
	CanTxStructure.IDE = CAN_Id_Standard;	
  
#elif (Frame_Format == Extended_Frame)
	CanTxStructure.ExtId = 0x12124567;		
	CanTxStructure.IDE = CAN_Id_Extended;	
	
#endif	
	
	CanTxStructure.RTR = CAN_RTR_Data;		
	CanTxStructure.DLC = len;
	
	for( i=0; i<len; i++ )
	{
		CanTxStructure.Data[i] = msg[i];	
	}
	
	mbox = CAN_Transmit( CAN1, &CanTxStructure);
	i = 0;
	
	while( ( CAN_TransmitStatus( CAN1, mbox ) != CAN_TxStatus_Ok ) && (i < 0xFFF) ) 
	{
		i++;
	}
	
	if( i == 0xFFF )
	{
		return 1;
	}
	else 
	{
		return 0;
	}	
}

/*********************************************************************
 * @fn      CAN_Receive_Msg
 *
 * @brief   CAN Receive function.
 *
 * @param   buf - Receive data buffer.
 *          len - Data length.
 *
 * @return  CanRxStructure.DLC - Receive data length.
 */
u8 CAN1_Receive_Msg( u8 *buf )
{
	u8 i;
	
	CanRxMsg CanRxStructure;
	
	if( CAN_MessagePending( CAN1, CAN_FIFO1 ) == 0)
	{
		return 0;
	}
	
	CAN_Receive( CAN1, CAN_FIFO1, &CanRxStructure );
	
	for( i=0; i<8; i++ )
	{
		buf[i] = CanRxStructure.Data[i];
	}
	
	return CanRxStructure.DLC;	
}

u8 CAN2_Receive_Msg( u8 *buf )
{
    u8 i;

    CanRxMsg CanRxStructure;

    if( CAN_MessagePending( CAN2, CAN_FIFO0 ) == 0)
    {
        return 0;
    }

    CAN_Receive( CAN2, CAN_FIFO0, &CanRxStructure );

    for( i=0; i<8; i++ )
    {
        buf[i] = CanRxStructure.Data[i];
    }

    return CanRxStructure.DLC;
}


void CAN1_RX1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void CAN1_RX1_IRQHandler(void)
{
    u8 i=0;
    u8 px;
    u8 pxbuf[8];

    if(CAN_GetITStatus(CAN1, CAN_IT_FMP1) != RESET)
    {
        CAN_ClearITPendingBit(CAN1, CAN_IT_FMP1);
        px = CAN1_Receive_Msg( pxbuf );
        if( px )
        {
            printf( "Enter CAN1 Interrupt:\r\n" );
            printf( "CAN1 Receive Data:\r\n" );

            for(i=0; i<8; i++)
            {
                printf( "%02x\r\n", pxbuf[i] );
            }
        }
    }
}

void CAN2_RX0_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void CAN2_RX0_IRQHandler(void)
{
    u8 i=0;
    u8 px;
    u8 pxbuf[8];

    if(CAN_GetITStatus(CAN2, CAN_IT_FMP0) != RESET)
    {
        CAN_ClearITPendingBit(CAN2, CAN_IT_FMP0);
        px = CAN2_Receive_Msg( pxbuf );
        if( px )
        {
            printf( "Enter CAN2 Interrupt:\r\n" );
            printf( "CAN2 Receive Data:\r\n" );

            for(i=0; i<8; i++)
            {
                printf( "%02x\r\n", pxbuf[i] );
            }
        }
    }
}
u8 i=0;
u8 cnt=1;
u8 px;
u8 pxbuf[8];

int main(void)
{
	Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);
	printf( "Rx Mode\r\n" );

/* Bps = 250Kbps */
	CAN_Mode_Init( CAN_SJW_1tq, CAN_BS2_5tq, CAN_BS1_6tq, 12, CAN_Mode_Normal );
	while(1)
	{
		Delay_Ms(1000);
		cnt++;
		
		if(cnt == 0xFF)
		{
			cnt = 0;
		}	
	}
}

